#include "queue.h"

bool queue_is_empty(queue* q) { return q->first == NULL; }
void queue_free(queue* q) { free(q); }

queue* queue_create() {
	queue* q = malloc(sizeof(queue));

	q->first = NULL;
	q->last = NULL;

	return q;
}

void queue_enqueue(queue* q, pixel* p) {
	node* n = new_node(p);

	if(q->last == NULL) q->first = n;
	else q->last->next = n;


	q->last = n;
}

pixel* queue_dequeue(queue* q) {
	if (q->first == NULL) return NULL;

	node* n = q->first;
	pixel* p = n->value;

	q->first = q->first->next;

	if(q->first == NULL) q->last = NULL;

	free_node(n);

	return p;
}
