#include "stack.h"

bool stack_is_empty(stack* s) { return *s == NULL; }
pixel* stack_peek(stack* s) { return (*s)->value; }
void stack_free(stack* s) { return free(s); }

stack* stack_create() {
	stack* s = malloc(sizeof(stack));
	*s = NULL;
	return s;
}

void stack_push(stack* s, pixel* p) {
	node* n = new_node(p);
	n->next = *s;
	*s = n;
}


pixel* stack_pop(stack* s) {
	if (stack_is_empty(s)) return NULL;

	node* n = *s;
	pixel* p = n->value;

	*s = (*s)->next;

	free_node(n);

	return p;
}

